<TeXmacs|1.99.2>

<style|<tuple|beamer|ring-session|mathemagix|caas>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        Sparse polynomial interpolation in practice
      </with>>

      <large|<em|<abbr|Joris> van der Hoeven>, Grgoire Lecerf>

      <\small>
        CNRS, cole polytechnique
      </small>
    </with>

    \;

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Issac,
      <with|font|Hiragino Kaku Gothic Pro|font-family|cjk|\<#795E\>\<#6238\>\<#5E02\><rsup|<hlink||http://fr.wikipedia.org/wiki/Aide:Japonais>>>,
      2014<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<TeXmacs*>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Motivation (implementation in upcoming <name|caas> package)>

    <\session|caas|default>
      <\folded-subsession>
        Matrices
      <|folded-subsession>
        <\input>
          <caas-prompt|5>
        <|input>
          M(n) == [ x[i,j] \| i in 1 to n \|\| j in 1 to n ];
        </input>

        <\folded-io>
          <caas-prompt|6>
        <|folded-io>
          M(2)
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|x<rsub|1,1>|x<rsub|2,1>>|<row|x<rsub|1,2>|x<rsub|2,2>>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|7>
        <|folded-io>
          invert M(2)
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|<frac|x<rsub|2,1>*x<rsub|1,2>|<around*|(|x<rsub|2,2>-<frac|x<rsub|2,1>*x<rsub|1,2>|x<rsub|1,1>>|)>*x<rsub|1,1><rsup|2>>+<frac|1|x<rsub|1,1>>|-<around*|(|<frac|x<rsub|2,1>|<around*|(|x<rsub|2,2>-<frac|x<rsub|2,1>*x<rsub|1,2>|x<rsub|1,1>>|)>*x<rsub|1,1>>|)>>|<row|-<around*|(|<frac|x<rsub|1,2>|<around*|(|x<rsub|2,2>-<frac|x<rsub|2,1>*x<rsub|1,2>|x<rsub|1,1>>|)>*x<rsub|1,1>>|)>|<frac|1|x<rsub|2,2>-<frac|x<rsub|2,1>*x<rsub|1,2>|x<rsub|1,1>>>>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|8>
        <|folded-io>
          simplify (M(12) * invert M(12))
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|1|0|0|0|0|0|0|0|0|0|0|0>|<row|0|1|0|0|0|0|0|0|0|0|0|0>|<row|0|0|1|0|0|0|0|0|0|0|0|0>|<row|0|0|0|1|0|0|0|0|0|0|0|0>|<row|0|0|0|0|1|0|0|0|0|0|0|0>|<row|0|0|0|0|0|1|0|0|0|0|0|0>|<row|0|0|0|0|0|0|1|0|0|0|0|0>|<row|0|0|0|0|0|0|0|1|0|0|0|0>|<row|0|0|0|0|0|0|0|0|1|0|0|0>|<row|0|0|0|0|0|0|0|0|0|1|0|0>|<row|0|0|0|0|0|0|0|0|0|0|1|0>|<row|0|0|0|0|0|0|0|0|0|0|0|1>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|10>
        <|folded-io>
          simplify transpose invert transpose invert M(8)
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|x<rsub|1,1>|x<rsub|2,1>|x<rsub|3,1>|x<rsub|4,1>|x<rsub|5,1>|x<rsub|6,1>|x<rsub|7,1>|x<rsub|8,1>>|<row|x<rsub|1,2>|x<rsub|2,2>|x<rsub|3,2>|x<rsub|4,2>|x<rsub|5,2>|x<rsub|6,2>|x<rsub|7,2>|x<rsub|8,2>>|<row|x<rsub|1,3>|x<rsub|2,3>|x<rsub|3,3>|x<rsub|4,3>|x<rsub|5,3>|x<rsub|6,3>|x<rsub|7,3>|x<rsub|8,3>>|<row|x<rsub|1,4>|x<rsub|2,4>|x<rsub|3,4>|x<rsub|4,4>|x<rsub|5,4>|x<rsub|6,4>|x<rsub|7,4>|x<rsub|8,4>>|<row|x<rsub|1,5>|x<rsub|2,5>|x<rsub|3,5>|x<rsub|4,5>|x<rsub|5,5>|x<rsub|6,5>|x<rsub|7,5>|x<rsub|8,5>>|<row|x<rsub|1,6>|x<rsub|2,6>|x<rsub|3,6>|x<rsub|4,6>|x<rsub|5,6>|x<rsub|6,6>|x<rsub|7,6>|x<rsub|8,6>>|<row|x<rsub|1,7>|x<rsub|2,7>|x<rsub|3,7>|x<rsub|4,7>|x<rsub|5,7>|x<rsub|6,7>|x<rsub|7,7>|x<rsub|8,7>>|<row|x<rsub|1,8>|x<rsub|2,8>|x<rsub|3,8>|x<rsub|4,8>|x<rsub|5,8>|x<rsub|6,8>|x<rsub|7,8>|x<rsub|8,8>>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|11>
        <|folded-io>
          simplify invert M(2)
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|<frac|x<rsub|2,2>|x<rsub|2,2>*x<rsub|1,1>-x<rsub|2,1>*x<rsub|1,2>>|-<around*|(|<frac|x<rsub|2,1>|x<rsub|2,2>*x<rsub|1,1>-x<rsub|2,1>*x<rsub|1,2>>|)>>|<row|-<around*|(|<frac|x<rsub|1,2>|x<rsub|2,2>*x<rsub|1,1>-x<rsub|2,1>*x<rsub|1,2>>|)>|<frac|x<rsub|1,1>|x<rsub|2,2>*x<rsub|1,1>-x<rsub|2,1>*x<rsub|1,2>>>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|12>
        <|folded-io>
          simplify invert M(3)
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|<frac|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>>|<row|<frac|x<rsub|3,2>*x<rsub|1,3>-x<rsub|3,3>*x<rsub|1,2>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|3,3>*x<rsub|1,1>-x<rsub|3,1>*x<rsub|1,3>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|3,1>*x<rsub|1,2>-x<rsub|3,2>*x<rsub|1,1>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>>|<row|<frac|x<rsub|2,3>*x<rsub|1,2>-x<rsub|2,2>*x<rsub|1,3>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|2,1>*x<rsub|1,3>-x<rsub|2,3>*x<rsub|1,1>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>|<frac|x<rsub|2,2>*x<rsub|1,1>-x<rsub|2,1>*x<rsub|1,2>|<around*|(|x<rsub|3,3>*x<rsub|2,2>-x<rsub|3,2>*x<rsub|2,3>|)>*x<rsub|1,1>+<around*|(|x<rsub|3,2>*x<rsub|2,1>-x<rsub|3,1>*x<rsub|2,2>|)>*x<rsub|1,3>+<around*|(|x<rsub|3,1>*x<rsub|2,3>-x<rsub|3,3>*x<rsub|2,1>|)>*x<rsub|1,2>>>>>|]>>
        </folded-io>

        <\input>
          <caas-prompt|13>
        <|input>
          \;
        </input>
      </folded-subsession>

      \;

      <\folded-subsession>
        Series
      <|folded-subsession>
        <\folded-io>
          <caas-prompt|13>
        <|folded-io>
          e1 == exp series (0, x + y)
        <|folded-io>
          <math|1+<around*|(|x+y|)>*z+<frac|1|2>*<around*|(|x+y|)><rsup|2>*z<rsup|2>+<frac|1|6>*<around*|(|x+y|)><rsup|3>*z<rsup|3>+<frac|1|24>*<around*|(|x+y|)><rsup|4>*z<rsup|4>+<frac|1|120>*<around*|(|x+y|)><rsup|5>*z<rsup|5>+<frac|1|720>*<around*|(|x+y|)><rsup|6>*z<rsup|6>+<frac|1|5040>*<around*|(|x+y|)><rsup|7>*z<rsup|7>+<frac|1|40320>*<around*|(|x+y|)><rsup|8>*z<rsup|8>+<frac|1|362880>*<around*|(|x+y|)><rsup|9>*z<rsup|9>+O<around*|(|z<rsup|10>|)>>
        </folded-io>

        <\folded-io>
          <caas-prompt|14>
        <|folded-io>
          e2 == exp series (0, x)
        <|folded-io>
          <math|1+x*z+<frac|1|2>*x<rsup|2>*z<rsup|2>+<frac|1|6>*x<rsup|3>*z<rsup|3>+<frac|1|24>*x<rsup|4>*z<rsup|4>+<frac|1|120>*x<rsup|5>*z<rsup|5>+<frac|1|720>*x<rsup|6>*z<rsup|6>+<frac|1|5040>*x<rsup|7>*z<rsup|7>+<frac|1|40320>*x<rsup|8>*z<rsup|8>+<frac|1|362880>*x<rsup|9>*z<rsup|9>+O<around*|(|z<rsup|10>|)>>
        </folded-io>

        <\folded-io>
          <caas-prompt|15>
        <|folded-io>
          e1 / e2
        <|folded-io>
          <math|1+y*z+<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*z<rsup|2>+<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*z<rsup|3>+<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*z<rsup|4>+<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*z<rsup|5>+<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*z<rsup|6>+<around*|(|-<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x-<frac|1|2>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|5>+<frac|1|5040>*<around*|(|x+y|)><rsup|7>-<frac|1|720>*x<rsup|6>*y-<frac|1|5040>*x<rsup|7>|)>*z<rsup|7>+<around*|(|-<around*|(|-<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x-<frac|1|2>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|5>+<frac|1|5040>*<around*|(|x+y|)><rsup|7>-<frac|1|720>*x<rsup|6>*y-<frac|1|5040>*x<rsup|7>|)>*x-<frac|1|2>*<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|5>-<frac|1|720>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|6>+<frac|1|40320>*<around*|(|x+y|)><rsup|8>-<frac|1|5040>*x<rsup|7>*y-<frac|1|40320>*x<rsup|8>|)>*z<rsup|8>+<around*|(|-<around*|(|-<around*|(|-<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x-<frac|1|2>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|5>+<frac|1|5040>*<around*|(|x+y|)><rsup|7>-<frac|1|720>*x<rsup|6>*y-<frac|1|5040>*x<rsup|7>|)>*x-<frac|1|2>*<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|5>-<frac|1|720>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|6>+<frac|1|40320>*<around*|(|x+y|)><rsup|8>-<frac|1|5040>*x<rsup|7>*y-<frac|1|40320>*x<rsup|8>|)>*x-<frac|1|2>*<around*|(|-<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x-<frac|1|2>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|5>+<frac|1|5040>*<around*|(|x+y|)><rsup|7>-<frac|1|720>*x<rsup|6>*y-<frac|1|5040>*x<rsup|7>|)>*x<rsup|2>-<frac|1|6>*<around*|(|-<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x-<frac|1|2>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|4>+<frac|1|720>*<around*|(|x+y|)><rsup|6>-<frac|1|120>*x<rsup|5>*y-<frac|1|720>*x<rsup|6>|)>*x<rsup|3>-<frac|1|24>*<around*|(|<frac|1|120>*<around*|(|x+y|)><rsup|5>-<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x-<frac|1|2>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|2>-<frac|1|6>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|3>-<frac|1|24>*x<rsup|4>*y-<frac|1|120>*x<rsup|5>|)>*x<rsup|4>-<frac|1|120>*<around*|(|<frac|1|24>*<around*|(|x+y|)><rsup|4>-<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x-<frac|1|2>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|2>-<frac|1|6>*x<rsup|3>*y-<frac|1|24>*x<rsup|4>|)>*x<rsup|5>-<frac|1|720>*<around*|(|<frac|1|6>*<around*|(|x+y|)><rsup|3>-<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x-<frac|1|2>*x<rsup|2>*y-<frac|1|6>*x<rsup|3>|)>*x<rsup|6>-<frac|1|5040>*<around*|(|<frac|1|2>*<around*|(|x+y|)><rsup|2>-<frac|1|2>*x<rsup|2>-x*y|)>*x<rsup|7>+<frac|1|362880>*<around*|(|x+y|)><rsup|9>-<frac|1|40320>*x<rsup|8>*y-<frac|1|362880>*x<rsup|9>|)>*z<rsup|9>+O<around*|(|z<rsup|10>|)>>
        </folded-io>

        <\folded-io>
          <caas-prompt|16>
        <|folded-io>
          q == simplify (e1 / e2)
        <|folded-io>
          <math|1+y*z+<frac|1|2>*y<rsup|2>*z<rsup|2>+<frac|1|6>*y<rsup|3>*z<rsup|3>+<frac|1|24>*y<rsup|4>*z<rsup|4>+<frac|1|120>*y<rsup|5>*z<rsup|5>+<frac|1|720>*y<rsup|6>*z<rsup|6>+<frac|1|5040>*y<rsup|7>*z<rsup|7>+<frac|1|40320>*y<rsup|8>*z<rsup|8>+<frac|1|362880>*y<rsup|9>*z<rsup|9>+O<around*|(|z<rsup|10>|)>>
        </folded-io>

        <\folded-io>
          <caas-prompt|6>
        <|folded-io>
          q [15]
        <|folded-io>
          <math|<frac|1|1307674368000>*y<rsup|15>>
        </folded-io>

        <\input>
          <caas-prompt|7>
        <|input>
          \;
        </input>
      </folded-subsession>
    </session>
  </hidden>|<\hidden>
    <tit|The problem>

    \;

    <unroll|<\shown>
      <math|\<bbb-K\>> field (usually <math|\<bbb-K\>=\<bbb-Q\>> or
      <math|\<bbb-K\>=\<bbb-F\><rsub|p>>)

      <switch|<\shown>
        <strong|Input:> an expression <math|P<rsup|expr>> in
        <math|x<rsub|1>,\<ldots\>,x<rsub|n>>, <math|+>, <math|->,
        <math|\<times\>>, <math|\<div\>> and constants in <math|\<bbb-K\>>
      </shown>|<\hidden>
        <strong|Input:> <left|{><tabular|<tformat|<table|<row|<cell|an
        expression <math|P<rsup|expr>> in
        <math|x<rsub|1>,\<ldots\>,x<rsub|n>>, <math|+>, <math|->,
        <math|\<times\>>, <math|\<div\>> and constants in <math|\<bbb-K\>>;
        or>>|<row|<cell|a function <math|P<rsup|fun>:\<bbb-K\><rsup|n>\<rightarrow\>\<bbb-K\>>>>>>>
      </hidden>>
    </shown>|<\hidden*>
      <switch|<\shown>
        <strong|Output:> a sparse polynomial
        <math|P=<big|sum><rsub|i=1><rsup|t>c<rsub|i>*x<rsup|e<rsub|i>>>
        representing <math|P<rsup|expr>> <abbr|resp.> <math|P<rsup|fun>>
      </shown>|<\hidden>
        <strong|Output:> <left|{><tabular|<tformat|<table|<row|<cell|a sparse
        polynomial <math|P=<big|sum><rsub|i=1><rsup|t>c<rsub|i>*x<rsup|e<rsub|i>>>
        representing <math|P<rsup|expr>> <abbr|resp.>
        <math|P<rsup|fun>>,>>|<row|<cell|where
        <math|c<rsub|i>\<in\>\<bbb-K\>\<setminus\><around*|{|0|}>>,
        <math|e<rsub|i>\<in\>\<bbb-N\><rsup|n>> pairwise distinct; or
        <math|\<perp\>>>>>>>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Optionally:> a bound on <math|t>, or on <math|d=deg P>, or on
      the <math|d<rsub|i>=deg<rsub|x<rsub|i>> P>
    </hidden*>|<\hidden*>
      \;

      <strong|Note:> in absence of a bound on <math|t>, we are satisfied with
      probabilistic algorithms

      For instance, picking <math|x\<assign\>\<alpha\>> random, we have
      <math|P<rsup|fun><around*|(|\<alpha\>|)>=0\<Leftrightarrow\>P=0> with
      high probability
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Interface issue>

    <\session|caas|default>
      <\folded-subsession>
        Classical
      <|folded-subsession>
        <\folded-io>
          <caas-prompt|17>
        <|folded-io>
          M == [ a, b; c, d ]
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|a|b>|<row|c|d>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|18>
        <|folded-io>
          M * invert M
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|<around*|(|<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a<rsup|2>>+<frac|1|a>|)>*a-<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a>|0>|<row|<around*|(|<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a<rsup|2>>+<frac|1|a>|)>*c-<frac|c*d|<around*|(|d-<frac|b*c|a>|)>*a>|<frac|d|d-<frac|b*c|a>>-<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a>>>>|]>>
        </folded-io>

        <\input>
          <caas-prompt|19>
        <|input>
          \;
        </input>
      </folded-subsession>

      <\folded-subsession>
        Zero simplified
      <|folded-subsession>
        <\folded-io>
          <caas-prompt|19>
        <|folded-io>
          M == [ force_simplify_zero a, b; c, d ]
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|a|b>|<row|c|d>>>|]>>
        </folded-io>

        <\folded-io>
          <caas-prompt|31>
        <|folded-io>
          M * invert M
        <|folded-io>
          <math|<around*|[|<tabular*|<table|<row|<around*|(|<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a<rsup|2>>+<frac|1|a>|)>*a-<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a>|0>|<row|0|<frac|d|d-<frac|b*c|a>>-<frac|b*c|<around*|(|d-<frac|b*c|a>|)>*a>>>>|]>>
        </folded-io>

        <\input>
          <caas-prompt|32>
        <|input>
          \;
        </input>
      </folded-subsession>
    </session>
  </hidden>|<\hidden>
    <tit|The meta-algorithm>

    <unroll|<\shown>
      Assume (for known <math|t>)

      <\eqnarray*>
        <tformat|<table|<row|<cell|P>|<cell|=>|<cell|<big|sum><rsub|i=1><rsup|t>c<rsub|i>*x<rsup|e<rsub|i>>.>>>>
      </eqnarray*>

      For all <math|\<alpha\>\<in\>\<bbb-K\><rsup|n>> we have

      <\eqnarray*>
        <tformat|<table|<row|<cell|f<around*|(|z|)>\<assign\><big|sum><rsub|i\<geqslant\>0>P<around*|(|\<alpha\><rsub|1><rsup|i>,\<ldots\>,\<alpha\><rsub|n><rsup|i>|)>*z<rsup|i>>|<cell|=>|<cell|<big|sum><rsub|1\<leqslant\>i\<leqslant\>t><frac|c<rsub|i>|1-\<alpha\><rsup|e<rsub|i>>*z>.<label|gen-ser>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      Choose <math|\<alpha\>> such that the <math|\<alpha\><rsup|e<rsub|i>>>
      are pairwise distinct
    </hidden*>|<\hidden*>
      <unroll|<\shown>
        Compute <math|c<rsub|1>,\<alpha\><rsup|e<rsub|1>>,\<ldots\>,c<rsub|t>,\<alpha\><rsup|e<rsub|t>>\<in\>\<bbb-K\>>
        from <math|f<rsub|0>,\<ldots\>,f<rsub|2*t-1>>
      </shown>|<\hidden*>
        <\itemize>
          <unroll|<\shown>
            <item>Find <math|A,B\<in\>\<bbb-K\><around*|[|z|]>> of degrees
            <math|\<less\>t> with <math|f<around*|(|z|)>=A<around*|(|z|)>/B<around*|(|z|)>>
            using Pad-Hermite
          </shown>|<\hidden*>
            <item>Find the roots <math|\<alpha\><rsup|e<rsub|1>>,\<ldots\>,\<alpha\><rsup|e<rsub|t>>>
            of <math|B>
          </hidden*>|<\hidden*>
            <item>Solve linear Vandermonde system in order to get the
            <math|c<rsub|i>>
          </hidden*>>
        </itemize>
      </hidden*>>
    </hidden*>|<\hidden*>
      Recover <math|e<rsub|1>,\<ldots\>,e<rsub|t>> from
      <math|\<alpha\><rsup|e<rsub|1>>,\<ldots\>,\<alpha\><rsup|e<rsub|t>>>
    </hidden*>|<\hidden*>
      Without bound for <math|t>, try for <math|t=1,2,4,8,16,\<ldots\>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Known variants>

    <\description>
      <unroll|<\shown>
        <item*|Prime numbers>[Ben-Or & Tiwari 1988], <math|\<bbb-K\>>
        characteristic zero

        <\compact>
          Take <math|\<alpha\><rsub|i>=\<pi\><rsub|i>> (the <math|i>-th prime
          number)

          Roots of integer polynomials can be computed fast

          <math|\<alpha\><rsup|e<rsub|i>>\<rightsquigarrow\>e<rsub|i>>
          <em|via> factoring
        </compact>
      </shown>|<\hidden*>
        <item*|Modular arithmetic>[Kaltofen & Lakshman & Wiley 1990],
        <name|Dagwood>

        <\compact>
          Pick a prime <math|p> such that <math|max<rsub|i>
          \<alpha\><rsup|e<rsub|i>>\<less\>p> (<abbr|e.g.>
          <math|\<pi\><rsub|n><rsup|d>\<less\>p>)

          Evaluate <math|P> using arithmetic modulo <math|p> only

          Find roots of polynomials in <math|\<bbb-F\><rsub|p>> using
          Cantor-Zassenhaus or Moenck (if <math|p=k*2<rsup|l>+1>)

          <math|\<alpha\><rsup|e<rsub|i>>\<rightsquigarrow\>e<rsub|i>>
          <em|via> factoring
        </compact>
      </hidden*>|<\hidden*>
        <item*|Kronecker approach>[Javadi & Monagan 2010], [Arnold & Roche
        2014]

        <\compact>
          Let <math|D<rsub|i>\<geqslant\>deg<rsub|x<rsub|i>> P+1>

          Let <math|p\<gtr\>D<rsub|1>*\<cdots\>*D<rsub|n>> and let
          <math|\<omega\>> be a primitive element in <math|\<bbb-F\><rsub|p>>

          Take <math|\<alpha\>=<around*|(|1,\<omega\><rsup|D<rsub|1>>,\<omega\><rsup|D<rsub|1>*D<rsub|2>>,\<ldots\>,\<omega\><rsup|D<rsub|1>*\<cdots\>*D<rsub|n-1>>|)>>

          Find roots of polynomials in <math|\<bbb-F\><rsub|p>> using
          Cantor-Zassenhaus or Moenck

          <math|\<alpha\><rsup|e<rsub|i>>=\<omega\><rsup|\<Pi\>\<cdot\>e<rsub|i>>\<rightsquigarrow\>e<rsub|i>>
          <em|via> discrete logarithm (fast if <math|p=k*2<rsup|l>+1>)
        </compact>
      </hidden*>>
    </description>
  </hidden>|<\hidden>
    <tit|Incremental approaches>

    <unroll|<\shown>
      <\rough-paper>
        Let <math|Q<around*|(|x<rsub|m+1>,\<ldots\>,x<rsub|n>|)>=P<around*|(|\<alpha\><rsub|1>,\<ldots\>,\<alpha\><rsub|m>,x<rsub|m+1>,\<ldots\>,x<rsub|n>|)>>
        for random <math|\<alpha\>>

        Problem: assuming <math|supp Q=<around*|{|f<rsub|1>,\<ldots\>,f<rsub|u>|}>>
        known, efficiently recover <math|supp P>

        Hope: possible using a much smaller <math|p> (fitting in one
        word)<htab|5mm>
      </rough-paper>
    </shown>|<\hidden*>
      <paragraph|Coefficient ratios.>[Javadi & Monagan, slightly different
      context], <math|\<pi\><rsub|1><rsup|e<rsub|i,1>>*\<cdots\>*\<pi\><rsub|m><rsup|e<rsub|i,m>>\<less\>p>

      <\eqnarray*>
        <tformat|<table|<row|<cell|f<around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>|<cell|\<rightsquigarrow\>>|<cell|c<rsub|i>,\<alpha\><rsup|e<rsub|i>>>>|<row|<cell|f<around*|(|\<pi\><rsub|1>*x<rsub|1>,\<ldots\>,\<pi\><rsub|m>*x<rsub|m>,x<rsub|m+1>,\<ldots\>,x<rsub|n>|)>>|<cell|\<rightsquigarrow\>>|<cell|\<pi\><rsub|1><rsup|e<rsub|i,1>>*\<cdots\>*\<pi\><rsub|m><rsup|e<rsub|i,m>>*c<rsub|i>,\<alpha\><rsup|e<rsub|i>><space|0.6spc>\<rightsquigarrow\><space|0.6spc><around*|\<nobracket\>|e<rsub|i,\<leqslant\>m>\<assign\><around*|(|e<rsub|i,1>,\<ldots\>,e<rsub|i,m>|)>|\<nobracket\>>>>|<row|<cell|\<alpha\><rsup|e<rsub|i>-e<rsub|i,\<leqslant\>m>>,supp
        Q>|<cell|\<rightsquigarrow\>>|<cell|e<rsub|i>>>>>
      </eqnarray*>

      Works also for Kronecker approach
    </hidden*>|<\hidden*>
      <paragraph|Closest point projections.><math|\<alpha\>=<around*|(|1,\<omega\><rsup|D<rsub|1>>,\<ldots\>,\<omega\><rsup|D<rsub|1>*\<cdots\>*D<rsub|m><rprime|'>*\<cdots\>*D<rsub|n-1>>|)>>,
      <math|D<rprime|'><rsub|m>\<gtr\>D<rsub|m>> random

      Consider <math|\<varphi\><rsub|i>\<in\><around*|{|0,\<ldots\>,p-2|}>>
      with <math|\<alpha\><rsup|f<rsub|i>>=\<omega\><rsup|\<varphi\><rsub|i>>>

      The <math|\<varphi\><rsub|i>> modulo <math|p-1> are essentially random
      with minimal distance <math|\<delta\>\<approx\>p/u<rsup|2>>

      Assume <math|D<rsub|1>*\<cdots\>*D<rsub|m>\<less\>\<delta\>>

      For any <math|e<rsub|i>\<in\>supp P> and <math|\<psi\><rsub|i>> with
      <math|\<alpha\><rsup|e<rsub|i>>=\<omega\><rsup|\<psi\><rsub|i>>>,
      <math|\<exists\>!\<varphi\><rsub|i<rprime|'>>> with
      <math|\<psi\><rsub|i>-\<varphi\><rsub|i<rprime|'>>\<less\>\<delta\>>
      (modulo <math|p-1>)
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Example: determinant of a matrix>

    Problem: interpolate generic <math|k\<times\>k> determinant

    <\eqnarray*>
      <tformat|<table|<row|<cell|P>|<cell|=>|<cell|<det|<tformat|<table|<row|<cell|x<rsub|1,1>>|<cell|\<cdots\>>|<cell|x<rsub|1,k>>>|<row|<cell|\<vdots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|x<rsub|k,1>>|<cell|\<cdots\>>|<cell|x<rsub|k,k>>>>>>>>>>
    </eqnarray*>

    \ <math|<with|math-display|true|>>

    Interesting parameters, since

    <\eqnarray*>
      <tformat|<table|<row|<cell|n>|<cell|=>|<cell|k<rsup|2>>>|<row|<cell|t>|<cell|=>|<cell|k!>>|<row|<cell|d>|<cell|=>|<cell|k>>|<row|<cell|d<rsub|i>>|<cell|=>|<cell|1>>>>
    </eqnarray*>

    \;

    <block|<tformat|<cwith|1|-1|2|-1|cell-halign|R.>|<table|<row|<cell|<math|n>>|<cell|4>|<cell|5>|<cell|6>|<cell|7>|<cell|8>|<cell|9>|<cell|10>|<cell|11>|<cell|12>>|<row|<cell|Bound
    <math|log<rsub|2> p> (primes)>|<cell|23>|<cell|33>|<cell|44>|<cell|55>|<cell|67>|<cell|79>|<cell|91>|<cell|104>|<cell|117>>|<row|<cell|Bound
    <math|log<rsub|2> p> (Kronecker)>|<cell|16>|<cell|25>|<cell|36>|<cell|49>|<cell|64>|<cell|81>|<cell|100>|<cell|121>|<cell|144>>>>>
  </hidden>|<\hidden>
    <tit|Implementation in <name|multimix> package>

    <\session|mathemagix|default>
      <\input>
        <mmx-prompt|1>
      <|input>
        use "multimix";
      </input>

      <\input>
        <mmx-prompt|24>
      <|input>
        n == 4;
      </input>

      <\folded-io>
        <mmx-prompt|32>
      <|folded-io>
        M == [ polynomial_dag (1 :\<gtr\> Integer, coordinate ('x[i,j])) \|

        \ \ \ \ \ \ \ i in 1 to n \|\| j in 1 to n ]
      <|folded-io>
        <math|<around*|[|<tabular*|<table|<row|x<rsub|1,1>|x<rsub|2,1>|x<rsub|3,1>|x<rsub|4,1>>|<row|x<rsub|1,2>|x<rsub|2,2>|x<rsub|3,2>|x<rsub|4,2>>|<row|x<rsub|1,3>|x<rsub|2,3>|x<rsub|3,3>|x<rsub|4,3>>|<row|x<rsub|1,4>|x<rsub|2,4>|x<rsub|3,4>|x<rsub|4,4>>>>|]>>
      </folded-io>

      <\folded-io>
        <mmx-prompt|33>
      <|folded-io>
        D == det M
      <|folded-io>
        <math|-<around*|(|x<rsub|1,4>*x<rsub|4,1>+x<rsub|2,4>*x<rsub|4,2>+x<rsub|3,4>*x<rsub|4,3>|)>*<around*|(|-x<rsub|1,3>*x<rsub|3,1>-x<rsub|2,3>*x<rsub|3,2>-x<rsub|3,3>*<around*|(|-x<rsub|2,2>-x<rsub|1,1>|)>-x<rsub|1,2>*x<rsub|2,1>+x<rsub|2,2>*x<rsub|1,1>|)>-<around*|(|x<rsub|1,4>*<around*|(|x<rsub|1,1>*x<rsub|4,1>+x<rsub|2,1>*x<rsub|4,2>+x<rsub|3,1>*x<rsub|4,3>|)>+x<rsub|2,4>*<around*|(|x<rsub|1,2>*x<rsub|4,1>+x<rsub|2,2>*x<rsub|4,2>+x<rsub|3,2>*x<rsub|4,3>|)>+x<rsub|3,4>*<around*|(|x<rsub|1,3>*x<rsub|4,1>+x<rsub|2,3>*x<rsub|4,2>+x<rsub|3,3>*x<rsub|4,3>|)>|)>*<around*|(|-x<rsub|3,3>-x<rsub|2,2>-x<rsub|1,1>|)>-x<rsub|1,4>*<around*|(|x<rsub|1,1>*<around*|(|x<rsub|1,1>*x<rsub|4,1>+x<rsub|2,1>*x<rsub|4,2>+x<rsub|3,1>*x<rsub|4,3>|)>+x<rsub|2,1>*<around*|(|x<rsub|1,2>*x<rsub|4,1>+x<rsub|2,2>*x<rsub|4,2>+x<rsub|3,2>*x<rsub|4,3>|)>+x<rsub|3,1>*<around*|(|x<rsub|1,3>*x<rsub|4,1>+x<rsub|2,3>*x<rsub|4,2>+x<rsub|3,3>*x<rsub|4,3>|)>|)>-x<rsub|2,4>*<around*|(|x<rsub|1,2>*<around*|(|x<rsub|1,1>*x<rsub|4,1>+x<rsub|2,1>*x<rsub|4,2>+x<rsub|3,1>*x<rsub|4,3>|)>+x<rsub|2,2>*<around*|(|x<rsub|1,2>*x<rsub|4,1>+x<rsub|2,2>*x<rsub|4,2>+x<rsub|3,2>*x<rsub|4,3>|)>+x<rsub|3,2>*<around*|(|x<rsub|1,3>*x<rsub|4,1>+x<rsub|2,3>*x<rsub|4,2>+x<rsub|3,3>*x<rsub|4,3>|)>|)>-x<rsub|3,4>*<around*|(|x<rsub|1,3>*<around*|(|x<rsub|1,1>*x<rsub|4,1>+x<rsub|2,1>*x<rsub|4,2>+x<rsub|3,1>*x<rsub|4,3>|)>+x<rsub|2,3>*<around*|(|x<rsub|1,2>*x<rsub|4,1>+x<rsub|2,2>*x<rsub|4,2>+x<rsub|3,2>*x<rsub|4,3>|)>+x<rsub|3,3>*<around*|(|x<rsub|1,3>*x<rsub|4,1>+x<rsub|2,3>*x<rsub|4,2>+x<rsub|3,3>*x<rsub|4,3>|)>|)>-x<rsub|4,4>*<around*|(|-<around*|(|x<rsub|1,3>*x<rsub|3,1>+x<rsub|2,3>*x<rsub|3,2>|)>*<around*|(|-x<rsub|2,2>-x<rsub|1,1>|)>-x<rsub|1,3>*<around*|(|x<rsub|1,1>*x<rsub|3,1>+x<rsub|2,1>*x<rsub|3,2>|)>-x<rsub|2,3>*<around*|(|x<rsub|1,2>*x<rsub|3,1>+x<rsub|2,2>*x<rsub|3,2>|)>-x<rsub|3,3>*<around*|(|-x<rsub|1,2>*x<rsub|2,1>+x<rsub|2,2>*x<rsub|1,1>|)>|)>>
      </folded-io>

      <\folded-io>
        <mmx-prompt|27>
      <|folded-io>
        as_mvpolynomial% (D)
      <|folded-io>
        <math|x<rsub|1,1>*x<rsub|2,2>*x<rsub|3,3>*x<rsub|4,4>-x<rsub|1,2>*x<rsub|2,1>*x<rsub|3,3>*x<rsub|4,4>-x<rsub|1,1>*x<rsub|2,3>*x<rsub|3,2>*x<rsub|4,4>+x<rsub|1,3>*x<rsub|2,1>*x<rsub|3,2>*x<rsub|4,4>+x<rsub|1,2>*x<rsub|2,3>*x<rsub|3,1>*x<rsub|4,4>-x<rsub|1,3>*x<rsub|2,2>*x<rsub|3,1>*x<rsub|4,4>-x<rsub|1,1>*x<rsub|2,2>*x<rsub|3,4>*x<rsub|4,3>+x<rsub|1,2>*x<rsub|2,1>*x<rsub|3,4>*x<rsub|4,3>+x<rsub|1,1>*x<rsub|2,4>*x<rsub|3,2>*x<rsub|4,3>-x<rsub|1,4>*x<rsub|2,1>*x<rsub|3,2>*x<rsub|4,3>-x<rsub|1,2>*x<rsub|2,4>*x<rsub|3,1>*x<rsub|4,3>+x<rsub|1,4>*x<rsub|2,2>*x<rsub|3,1>*x<rsub|4,3>+x<rsub|1,1>*x<rsub|2,3>*x<rsub|3,4>*x<rsub|4,2>-x<rsub|1,3>*x<rsub|2,1>*x<rsub|3,4>*x<rsub|4,2>-x<rsub|1,1>*x<rsub|2,4>*x<rsub|3,3>*x<rsub|4,2>+x<rsub|1,4>*x<rsub|2,1>*x<rsub|3,3>*x<rsub|4,2>+x<rsub|1,3>*x<rsub|2,4>*x<rsub|3,1>*x<rsub|4,2>-x<rsub|1,4>*x<rsub|2,3>*x<rsub|3,1>*x<rsub|4,2>-x<rsub|1,2>*x<rsub|2,3>*x<rsub|3,4>*x<rsub|4,1>+x<rsub|1,3>*x<rsub|2,2>*x<rsub|3,4>*x<rsub|4,1>+x<rsub|1,2>*x<rsub|2,4>*x<rsub|3,3>*x<rsub|4,1>-x<rsub|1,4>*x<rsub|2,2>*x<rsub|3,3>*x<rsub|4,1>-x<rsub|1,3>*x<rsub|2,4>*x<rsub|3,2>*x<rsub|4,1>+x<rsub|1,4>*x<rsub|2,3>*x<rsub|3,2>*x<rsub|4,1>>
      </folded-io>

      <\input>
        <mmx-prompt|28>
      <|input>
        \;
      </input>
    </session>
  </hidden>|<\hidden>
    <tit|C++ API>

    <\cpp-code>
      template\<less\>int n\<gtr\> integer

      det_modulo (const vector\<less\>integer\<gtr\>& v /* n x n matrix
      coefficients */,

      \ \ \ \ \ \ \ \ \ \ \ \ const integer& p);
    </cpp-code>

    <\cpp-code>
      template\<less\>int n\<gtr\> void

      print_generic_determinant () {

      \ \ function_2\<less\>integer, const vector\<less\>integer\<gtr\>&,
      const integer&\<gtr\>

      \ \ \ \ f (&det_modulo\<less\>n\<gtr\>);

      \ \ sparse_polynomial\<less\>integer\<gtr\> pol =

      \ \ \ \ pr_as_sparse_polynomial (f, n*n, n /* degree bound */);

      \ \ mmout \<less\>\<less\> pol \<less\>\<less\> lf;

      }
    </cpp-code>

    <big-table|<block|<tformat|<cwith|1|1|2|-1|cell-halign|c>|<cwith|1|1|1|1|cell-halign|c>|<table|<row|<cell|<math|n>>|<cell|5>|<cell|6>|<cell|7>|<cell|8>>|<row|<cell|Kronecker
    substitution>|<cell|110<nbsp>ms>|<cell|915<nbsp>ms>|<cell|9.8<nbsp>s>|<cell|162<nbsp>s>>>>>|<label|tab:bench2>Timings
    for interpolating the determinant polynomial of a <math|n\<times\>n>
    matrix.>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-screen-bot|5mm>
    <associate|page-screen-top|5mm>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-2|<tuple|2|?>>
    <associate|auto-3|<tuple|1|?>>
    <associate|firstHeading|<tuple|1|?>>
    <associate|gen-ser|<tuple|?|?>>
    <associate|tab:bench2|<tuple|1|?>>
    <associate|wrap-fig|<tuple|?|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|table>
      <tuple|normal|Timings for interpolating the determinant polynomial of a
      <with|color|<quote|#503050>|font-family|<quote|rm>|<with|mode|<quote|math>|n\<times\>n>>
      matrix.|<pageref|auto-3>>
    </associate>
    <\associate|toc>
      <with|par-left|<quote|4tab>|Coefficient ratios.
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-1><vspace|0.15fn>>

      <with|par-left|<quote|4tab>|Closest point projections.
      <datoms|<macro|x|<repeat|<arg|x>|<with|font-series|medium|<with|font-size|1|<space|0.2fn>.<space|0.2fn>>>>>|<htab|5mm>>
      <no-break><pageref|auto-2><vspace|0.15fn>>
    </associate>
  </collection>
</auxiliary>